/*
 * Project GpioLedTestVSC
 * Description: Test mikrobus gpio pins with TESTER click
 * Author: Luka Filipovic
 * Date: 29.11.2019.
 */

#include "stdint.h"

#define _MIKROBUS_1
// #define _MIKROBUS_2

#ifdef _MIKROBUS_1
uint8_t AN_PIN =    19;
uint8_t RST_PIN =   17;
uint8_t CS_PIN =    14;
uint8_t SCK_PIN =   13;
uint8_t MISO_PIN =  11;
uint8_t MOSI_PIN =  12;
uint8_t PWM_PIN =   16;
uint8_t INT_PIN =   15;
uint8_t RX_PIN =    10;
uint8_t TX_PIN =    9 ;
uint8_t SCL_PIN =   1 ;
uint8_t SDA_PIN =   0 ;
#endif

#ifdef _MIKROBUS_2
uint8_t AN_PIN =    18;
uint8_t RST_PIN =   7 ;
uint8_t CS_PIN =    5 ;
uint8_t SCK_PIN =   13;
uint8_t MISO_PIN =  11;
uint8_t MOSI_PIN =  12;
uint8_t PWM_PIN =   8 ;
uint8_t INT_PIN =   6 ;
uint8_t RX_PIN =    10;
uint8_t TX_PIN =    9 ;
uint8_t SCL_PIN =   1 ;
uint8_t SDA_PIN =   0 ;
#endif

void systemInit()
{
    pinMode(AN_PIN, OUTPUT);
    pinMode(RST_PIN, OUTPUT);
    pinMode(CS_PIN, OUTPUT);
    pinMode(SCK_PIN, OUTPUT);
    pinMode(MISO_PIN, OUTPUT);
    pinMode(MOSI_PIN, OUTPUT);
    pinMode(PWM_PIN, OUTPUT);
    pinMode(INT_PIN, OUTPUT);
    pinMode(RX_PIN, OUTPUT);
    pinMode(TX_PIN, OUTPUT);
    pinMode(SCL_PIN, OUTPUT);
    pinMode(SDA_PIN, OUTPUT);
}

void applicationInit()
{
   digitalWrite(AN_PIN, 0);
   digitalWrite(RST_PIN, 0);
   digitalWrite(CS_PIN, 0);
   digitalWrite(SCK_PIN, 0);
   digitalWrite(MISO_PIN, 0);
   digitalWrite(MOSI_PIN, 0);
   digitalWrite(PWM_PIN, 0);
   digitalWrite(INT_PIN, 0);
   digitalWrite(RX_PIN, 0);
   digitalWrite(TX_PIN, 0);
   digitalWrite(SCL_PIN, 0);
   digitalWrite(SDA_PIN, 0);

   Serial.begin(9600);
   Serial.println("---- System init ------");
}

void applicationTask()
{
    int stateOfPin;

    digitalWrite(AN_PIN, 1);

    stateOfPin = digitalRead(AN_PIN);
    Serial.println(stateOfPin);
    delay(100);

    digitalWrite(AN_PIN, 0);
    digitalWrite(RST_PIN, 1);

    stateOfPin = digitalRead(AN_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(RST_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(RST_PIN, 0);
    digitalWrite(CS_PIN, 1);

    stateOfPin = digitalRead(RST_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(CS_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(CS_PIN, 0);
    digitalWrite(SCK_PIN, 1);

    stateOfPin = digitalRead(CS_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(SCK_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(SCK_PIN, 0);
    digitalWrite(MISO_PIN, 1);

    stateOfPin = digitalRead(SCK_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(MISO_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(MISO_PIN, 0);
    digitalWrite(MOSI_PIN, 1);

    stateOfPin = digitalRead(MISO_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(MOSI_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(MOSI_PIN, 0);
    digitalWrite(SDA_PIN, 1);

    stateOfPin = digitalRead(MOSI_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(SDA_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(SDA_PIN, 0);
    digitalWrite(SCL_PIN, 1);

    stateOfPin = digitalRead(SDA_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(SCL_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(SCL_PIN, 0);
    digitalWrite(TX_PIN, 1);

    stateOfPin = digitalRead(SCL_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(TX_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(TX_PIN, 0);
    digitalWrite(RX_PIN, 1);

    stateOfPin = digitalRead(TX_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(RX_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(RX_PIN, 0);
    digitalWrite(INT_PIN, 1);

    stateOfPin = digitalRead(RX_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(INT_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(INT_PIN, 0);
    digitalWrite(PWM_PIN, 1);

    stateOfPin = digitalRead(INT_PIN);
    Serial.println(stateOfPin);
    stateOfPin = digitalRead(PWM_PIN);
    Serial.println(stateOfPin);

    delay(100);

    digitalWrite(PWM_PIN, 0);

    stateOfPin = digitalRead(PWM_PIN);
    Serial.println(stateOfPin);

    delay(100);
}


void setup()
{
    systemInit();
    applicationInit();
}

void loop()
{
    applicationTask();
}
